{$R-} {$N+} {$E-} {use Copro, no Emu} {$D+}{$L+} {Debug}
program Argon; {Insomniacs 128by-Intro Argon changed to Pas (!) by EA 5/98}
uses EAVESA; {'etwas' grer als 128 Bytes} {Vesaversion}

const XXX=640; YYY=480; SCRL=50; {max 100 sinnvoll - ber 425 nur 1 Page da}
const speed=1; sc_x=6.0; sc_y=3.0;
const pg2swap:boolean=false; swapping:boolean=true; mode_x:boolean=false;
const pi=3.1415926;
type fp=double; {Org.: 8.8}

var sintab:array[0..255] of shortint;
var maxx,maxy,mx2, xby:integer; vramw:^WORDS;
var timer:dword absolute $40:$6c; rom:ram absolute $c000:0;
var moving:dword; xscroll,yscroll:longint; pg2ofs,pg2page:longint;

function _keypressed:boolean; begin
 _keypressed:=memw[$40:$1a]<>memw[$40:$1c]; end;
function _readkey:char; begin
 _readkey:=chr(mem[$40:memw[$40:$1a]]); inline($b8/>0/$16cd); end;

procedure setRGBpalette( num,r,g,b:integer ); begin
 port[$3c8]:=num; port[$3c9]:=r; port[$3c9]:=g; port[$3c9]:=b; end;

procedure mksin; var idx:integer; const s_unit=(pi+pi)/256; begin
 for idx:=0 to 255 do sintab[idx]:=trunc(128.0*sin(s_unit*idx)); end;

procedure mkpal; var idx:integer; begin for idx:=0 to 63 do begin
 setRGBpalette(idx, idx,0,0);     setRGBpalette(127-idx, idx,0,0); {S-R R-S}
 setRGBpalette(128+idx, 0,idx,0); setRGBpalette(255-idx, 0,idx,0); {S-G G-S}
end; end;

procedure nextpic; const cvt:fp=(pi+pi)/256.0;
var _speed,xrol, ybase,page64, c1,c2,v, x_x,y:word; x_sin,y_sin:integer;
begin ybase:=0; vramw:=@vram^[0];
if VESA_SET_Y_BASE(0) then; vramw:=@vram^[0];
if (swapping=true) and (pg2swap=true) then page64:=pg2page else page64:=0;
VESA_SET_PAGE64(page64);
if (pg2swap=false) and (swapping=true) then
 VESA_SET_POS( xscroll+pg2ofs+round(sin(cvt*sc_x*moving)*xscroll),
               yscroll+round(cos(cvt*sc_y*moving)*yscroll) ) else
 VESA_SET_POS( xscroll+round(sin(cvt*sc_x*moving)*xscroll),
               yscroll+round(cos(cvt*sc_y*moving)*yscroll) );
pg2swap:=not(pg2swap);

for y:=0 to maxy do begin   _speed:=(y-ybase)*xby; xrol:=$100;
 y_sin:=sintab[lo(moving+(y shr 1))]; {Wellen v.u.n.o.} {y shr 1 wg. HiRes}

 for x_x:=0 to mx2 do begin
  x_sin:=sintab[lo(y_sin+(x_x shr 1))];
   {Wellen v.l.n.r., offset Wellen v.u.n.o. - x_x shr 1 wg. HiRes}
   v:=x_sin-(moving); c2:=y+y; c1:=lo(v+c2); c2:=lo(v-c2); {Erics formula}
  if (y and 1)=0 then begin v:=c1; c1:=c2; c2:=v; end;
  if mode_x then begin
   portw[$3c4]:=xrol+2; xrol:=xrol shl 1; vram^[_speed]:=c1;
   portw[$3c4]:=xrol+2; xrol:=xrol shl 1; vram^[_speed]:=c2;
   if xrol>=$1000 then begin xrol:=$100; inc(_speed); end;
  end else begin
   vramw^[_speed shr 1]:=($ff00 and swap(c2)) or c1; inc(_speed,2);
  end;
  if _speed=0 {Overflow} then begin inc(page64); VESA_SET_PAGE64(page64); end;
end; {xloop} end; {y} end;

{procedure main} var rk:char; long:longint; begin   mksin;
 if mode_x then begin
  if not VESA_INIT(XXX,YYY,8,MODEX_M) then begin
   if not VESA_INIT(XXX,YYY,8,MCGA_M) then begin VESA_END; halt(1); end;
   if not VESA_MAKE_MODEX then mode_x:=false; end;
 end else begin
  if not VESA_INIT(XXX,YYY,8,MCGA_M) then begin VESA_END; halt(1); end;
 end; {PS: mode_x:=(maxx div xby)>1;}
 mkpal;  yscroll:=VESA_SET_X_BUF(SCRL+SCRL);
 maxx:=VESA_X-1; mx2:=maxx shr 1; maxy:=VESA_Y-1; xby:=VESA_X_BY;
 xscroll:=(VESA_X-XXX) shr 1;
 yscroll:=yscroll shr 1; if yscroll>SCRL then yscroll:=SCRL;
 inc(maxy,SCRL+SCRL);
 VESA_SET_PAGE64(0); if VESA_SET_Y_BASE(0) then; vramw:=@vram^[0];
 pg2ofs:=(longint(maxx+1)*longint(maxy+1))+65535;
 pg2page:=pg2ofs shr 16; pg2ofs:=pg2page shl 16;
 swapping:=swapping and ( (pg2ofs+pg2ofs)<=(longint(vesaram)*1024) );

 rk:=#234; moving:=0; repeat nextpic; inc(moving,speed);
  if _keypressed then begin rk:=_readkey; {interpretiere...} end;
 until rk=#27;
VESA_END; end.
